# -*- coding: utf-8 -*-

"""
verizonthingspacequalityofserviceapiendpoints

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from verizonthingspacequalityofserviceapiendpoints.api_helper import APIHelper
from verizonthingspacequalityofserviceapiendpoints.configuration import Server
from verizonthingspacequalityofserviceapiendpoints.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from verizonthingspacequalityofserviceapiendpoints.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from verizonthingspacequalityofserviceapiendpoints.models.consent_transaction_id import ConsentTransactionID
from verizonthingspacequalityofserviceapiendpoints.exceptions.device_location_result_exception import DeviceLocationResultException


class ExclusionsController(BaseController):

    """A Controller to access Endpoints in the verizonthingspacequalityofserviceapiendpoints API."""
    def __init__(self, config):
        super(ExclusionsController, self).__init__(config)

    def devices_location_give_consent_async(self,
                                            body=None):
        """Does a POST request to /devicelocations/action/consents.

        Create a consent record to use location services as an asynchronous
        request.

        Args:
            body (AccountConsentCreate, optional): Account details to create a
                consent record.

        Returns:
            ConsentTransactionID: Response from the API. List of JSON objects,
                each containing the position data or an error for a device in
                the request.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.THINGSPACE)
            .path('/devicelocations/action/consents')
            .http_method(HttpMethodEnum.POST)
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(And(Single('thingspace_oauth'), Single('vz-m2m-session_token')))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(ConsentTransactionID.from_dictionary)
            .local_error('default', 'Unexpected error.', DeviceLocationResultException)
        ).execute()
