# -*- coding: utf-8 -*-

"""
verizonthingspacequalityofserviceapiendpoints

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from verizonthingspacequalityofserviceapiendpoints.api_helper import APIHelper
from verizonthingspacequalityofserviceapiendpoints.configuration import Server
from verizonthingspacequalityofserviceapiendpoints.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from verizonthingspacequalityofserviceapiendpoints.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from verizonthingspacequalityofserviceapiendpoints.models.m_201_success import M201success
from verizonthingspacequalityofserviceapiendpoints.exceptions.default_exception import DefaultException


class ThingSpaceQualityOfServiceAPIActionsController(BaseController):

    """A Controller to access Endpoints in the verizonthingspacequalityofserviceapiendpoints API."""
    def __init__(self, config):
        super(ThingSpaceQualityOfServiceAPIActionsController, self).__init__(config)

    def create_a_thing_space_quality_of_service_api_subscription(self,
                                                                 body):
        """Does a POST request to /actions/enhanceQoS.

        Creates a QoS elevation subscription ID and activates the subscription.

        Args:
            body (SubscribeRequest): The request details to create a
                ThingSpace Quality of Service API subscription.

        Returns:
            M201success: Response from the API. Success Response

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.THINGSPACE)
            .path('/actions/enhanceQoS')
            .http_method(HttpMethodEnum.POST)
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(And(Single('thingspace_oauth'), Single('vz-m2m-session_token')))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(M201success.from_dictionary)
            .local_error('default', 'Error Response', DefaultException)
        ).execute()

    def stop_a_thing_space_quality_of_service_api_subscription(self,
                                                               account_name,
                                                               qos_subscription_id):
        """Does a DELETE request to /actions/enhanceQoS.

        Stops an active ThingSpace Quality of Service API subscription using
        the account name and the subscription ID.

        Args:
            account_name (str): TODO: type description here.
            qos_subscription_id (str): TODO: type description here.

        Returns:
            M201success: Response from the API. Success Response

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.THINGSPACE)
            .path('/actions/enhanceQoS')
            .http_method(HttpMethodEnum.DELETE)
            .query_param(Parameter()
                         .key('accountName')
                         .value(account_name))
            .query_param(Parameter()
                         .key('qosSubscriptionId')
                         .value(qos_subscription_id))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(And(Single('thingspace_oauth'), Single('vz-m2m-session_token')))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(M201success.from_dictionary)
            .local_error('default', 'Error Response', DefaultException)
        ).execute()
